/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 1597 2009-06-29 09:42:56Z ertl-honda $
 */

/*
 *  åȰ¸⥸塼MS7727CP01ѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "pdic/st16c2550/st16c2550.h"

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
    /*
     *  ץå¸ν
     */
    prc_initialize();
    
    /* PINT7 Hight٥Ǽ */
    sil_wrh_mem((void*)ICR2,
                (sil_reh_mem((void*)ICR2) | ICR2_PINT7S));

    /* PINT6 Hight٥Ǽ */
    sil_wrh_mem((void*)ICR2,
                (sil_reh_mem((void*)ICR2) | ICR2_PINT6S));    
    
    /*
     * СʡѤΥꥢ륳ȥν
     */
    st16c2550_init();    
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
    /*
     *  ץå¸νλ
     */
    prc_terminate();

    /*
     *  ȯĶ¸νλ
     */
    ms7727cp01_exit();

    /*
     * ˤʤ
     */
    while(1);
}

/*
 *  ƥ٥ϤΤʸ
 */
void
target_fput_log(char_t c)
{
    if (c == '\n') {
        st16c2550_pol_putc('\r', 1);
    }
    st16c2550_pol_putc(c, 1);
}
